#!/bin/sh
#$ -S /bin/sh
#Version1.0	hewm@genomics.org.cn	2010-09-29
BinDir=/ifs2/PLANT/single_cell/bin/Population/Tree
OUTDir=`pwd`
individual=$OUTDir/individual.txt
add_ref_list=$OUTDir/add_ref.list

usage()
{
    echo "usage:sh $0  individual.txt add_ref.list  OutDir"
}
if [ $# -eq 3 ]
then
    individual=$1
    add_ref_list=$2
    OutDir=$3
elif [ $# -eq 2 ]
then
    individual=$1
    add_ref_list=$2
elif [ $# -eq 1 ]
then
    individual=$1
fi
if [ -s $add_ref_list  ]; then
    :
else
    usage
    exit 1
fi
if [ -s $individual  ]; then
    :
else
    usage
    exit 1
fi

echo Start Time : 
date
perl	$BinDir/cat_genotype.pl	$add_ref_list	>	$OUTDir/Gm.genotype	
SnpNum=`tail -1   $OUTDir/Gm.genotype  | cut -f 2 | tr -d "\n" ` 
perl	$BinDir/Com_for_tree_V3.pl	$OUTDir/Gm.genotype	$SnpNum	$individual AA	Gm	$OUTDir/Gm.com
perl	$BinDir/whole_pdistance.pl	$OUTDir	$OUTDir/individual.datamatrix	
$BinDir/fneighbor	-datafile	$OUTDir/individual.datamatrix	-outfile	$OUTDir/tree.out1	-matrixtype	s	-treetype	n	-outtreefile	$OUTDir/tree.out2	
echo End Time : 
date

###############  swimming in the sky and flying in the sea ###########
