#!/usr/bin/perl
use File::Basename;
use FindBin qw($Bin);
my $dir=shift;
my $cut_off=shift;
my $distance=shift;
my $window=shift;
$cut_off ||=0.95;
$distance ||=50000;


my %size=(
'Chr2'   => '23174626',
'Chr6'  => '29076228',
'Chr7' => '19226500',
'Chr4' => '23425844',
'Chr1' => '29149675',
'Chr3' => '39782674',
'Chr5'  => '28023477',
'ChrU' => '4622709',

);

my $file_name=basename $dir;
mkdir  $file_name unless (-d $file_name);
chomp $dir;

my @aa=split(/\_/,$file_name);
my $out_file="$file_name/$aa[0]\_RoD";

open OUT,">$out_file" or die "$!";
open IN,"$dir/select/$aa[0]\_rod_fst";
my %rod;
while(<IN>){
	chomp;
	my @f=split;
	next if($f[4]<100);
        my $aa=1/(1-$f[0]);
        $aa=150 if($aa>150);
        $aa=0.25 if($aa<0.25);
#	my $lo=int $f[3]/10000;
	$f[3]+=25000;
	next if(($f[3]+25000)>$size{$f[2]});
	print OUT "$f[2]\t$f[3]\t$aa\n";
#        $rod{$f[2]}{$lo}=$aa;
#	print OUT "$f[2]\t$f[3]\t$f[0]\n";
}
close IN;
=pod
foreach my $chr(sort keys %rod){
	foreach my $lo(sort {$a<=>$b} keys %{$rod{$chr}}){
		my $val=0;
		my $count=0;
		for(my $i=$lo-2;$i<=$lo+2;$i++){
			if(defined $rod{$chr}{$i}){
				$val+=$rod{$chr}{$i};
				$count++;
			}
		}
		my $mean=$val/$count;
		my $loci=$lo*10000;
		print OUT "$chr\t$loci\t$mean\n";
	}
}
=cut
close OUT;

##############    point  select   #################
my $r_file="$out_file.R";

open R,">$r_file" or die "$!";
my $aa=100-100*$cut_off;
print R "read.table(\"$out_file\")->ch
ch\$V3->xx
quantile(xx,probs=$cut_off)->xa
xa
write(xa,file=\"$file_name\_top_$aa.txt\",append =TRUE)
q()\n";
close R;
`R < $r_file --vanilla`;

open IN,"$file_name\_top_$aa.txt" or die  "$!";
my $top_cut;
while(<IN>){
	chomp;
	$top_cut=$_;
}
close IN;


open  IA,$out_file or die  "$!";
my $select="$out_file.select";
open  OA,">$select" or die "$!";
my %region;
while(<IA>){
	chomp;
	my @f=split;
	if($f[2]>$top_cut){
		push @{$region{$f[0]}},$f[1];
		print OA "$_\n";
	}
}
close OA;
close IA;


my $select_region="$select.region";
open RE,">$select_region" or die "$!";
foreach my $chr(sort keys %region){
	my @aa=@{$region{$chr}};
	@aa=sort {$a<=>$b}@aa;
	my $st=$aa[0]-25000;
	my $en=$aa[0]+25000;
	$st=0 if($st<0);
	for(my $i=1;$i<=$#aa;$i++){
		if(($en+$distance)>=($aa[$i]-25000)){
			$en=$aa[$i]+25000;
		}else{
			my $len=$en-$st;
			print RE "$chr\t$st\t$en\t$len\n";
			$st=$aa[$i]-25000;
			$st=0 if($st<0);
			$en=$aa[$i]+25000;
		}
	}
	my $len=$en-$st;
	print RE "$chr\t$st\t$en\t$len\n";

}
close RE;



