#!/usr/bin/perl -w
use strict;
#use Getopt::Long;
sub usage{
  print STDERR <<USAGE;
      ############################################
            Version 1.0 by Wing-L

      usage: $0 <*.GABRIELblocks_list> >*_block.log

      ############################################
USAGE
exit;
}
&usage if(@ARGV ==0);
my (@list)=@ARGV;
#my ();
#GetOptions(
#  ""=>\,
#  ""=>\,
#  ""=>\,
#  ""=>\,
#);

foreach my $e (@list){
    my (%file,@block,@test);
    open IN,"<$e" or die("$!\n");
    while(my $line=<IN>){
        chomp $line;
        $line=~/(\S+)\.genotype\.ped\.GABRIELblocks$/;
        $file{$1}=$line;
    }
    close IN;
    $e=~s/\.\S+$//;
    open BLOCK,">${e}_block.log" or die("$!\n");
    open TEST,">${e}_test.log" or die("$!\n");
    foreach my $k (keys %file){
        my $last=defined $block[0]?$#block+1:0;
        my $tlast=defined $test[0]?$#test+1:0;
        my (%bk,%ck,%dk,%ek);
        ## read *.GABRIELblocks
        open IN,"<$file{$k}" or die("$!\n");
        while(my $line=<IN>){
            if($line=~/^BLOCK \d+\.\s+ MARKERS: ([^\n]+)/){
                my @tmp=(sort {$a <=> $b} (split /\s+/,$1));
                push @block,[@tmp];
                map {$bk{$tmp[$_]}=\$block[-1][$_]} (0..$#tmp);
            }
        }
        close IN;
        ## read *.test
        if(-e "$k.genotype.ped.TESTS"){
            open IN,"<$k.genotype.ped.TESTS" or die("$!\n");
            while(my $line=<IN>){
                chomp $line;
                push @test,[($line,0)];
                $dk{$line}=1;
            }
            close IN;
        }
        ## read *.genotype.info
        open IN,"<$k.genotype.info" or die("$!\n");
        while(my $line=<IN>){
            my @info=(split /\s+/,$line);
            if(defined $bk{$info[0]}){
                ${$bk{$info[0]}}=$info[1];
                $ck{$info[1]}++;
            }
            if(defined $dk{$info[0]}){
                $dk{$info[0]}=$info[1];
                $ek{$info[1]}=1;
            }
        }
        close IN;
        ## read *.genotype
        open IN,"<$k.genotype" or die("$!\n");
        while(my $line=<IN>){
            my @info=(split /\s+/,$line);
            if(defined $ck{$info[1]}){
                $ck{$info[1]}=$info[0];
            }
            if(defined $ek{$info[1]}){
                $ek{$info[1]}=$info[0];
            }
        }
        close IN;
        map {push @{$block[$_]},$ck{$block[$_][0]}} ($last..$#block);
        map { @{$test[$_]}=($ek{$dk{$test[$_][0]}},$dk{$test[$_][0]}) } ($tlast..$#test);
    }
    @block=sort {${$a}[-1] cmp ${$b}[-1] or ${$a}[0] <=> ${$b}[0]} @block;
    @test=sort {$a->[0] cmp $b->[0] or $a->[1] <=> $b->[1] } @test;
    foreach my $y (0..$#test){
        print TEST "$test[$y][0]\t$test[$y][1]\n";
    }
    my %x;
    foreach my $i (0..$#block){
        $x{$block[$i][-1]}=1 if(!defined $x{$block[$i][-1]});
        print BLOCK "$block[$i][-1]\t$x{$block[$i][-1]}\t$block[$i][0]\t$block[$i][-2]\n";
        $x{$block[$i][-1]}++;
    }
    close BLOCK;
    close TEST;
    print STDERR "finished $e\n";
}
#open IN,"<" or die("$!\n");
#while(my $line=<IN>){}
#foreach my $e (){}
#(split /\s+/,$line)[0]
#open OUT,">" or die("$!\n");
###############  sub  ###############
