import numpy
import dadi
import demographic_models
from numpy import array

#fsms=dadi.Spectrum.from_ms_file("test.ms",pop_assignments=[60,74,58])
#fsms.to_file("test.fs")
fsms=dadi.Spectrum.from_file("test.fs")
fsms=fsms.fold()
data = dadi.Spectrum.from_file('with_outgroup_new.three_pop_syn.fs')
data=data.fold()
ns = data.sample_sizes
pts_l = [40,50,60]
func = demographic_models.sthree_pop_one_split
params = array([0.041828,0.161332,0.22637,0.319451,1.58996,0.160053,0.160722,0.042640])
func_ex = dadi.Numerics.make_extrap_log_func(func)
model = func_ex(params, ns, pts_l)
theta = dadi.Inference.optimal_sfs_scaling(model, data)


#pi=fsms.pi()
#D=fsms.Tajima_D()
#S=fsms.S()
#Fst=fsms.Fst()

#print ' SegregationSites:',S, ' Fst:',Fst

import pylab
dadi.Plotting.plot_3d_spectrum(fsms)
dadi.Plotting.plot_3d_spectrum(data)
dadi.Plotting.plot_3d_spectrum(model)
dadi.Plotting.plot_3d_comp_multinom(theta*fsms, data, vmin=1, pop_ids =('Indian','EastAsian',"Eurasian"))
dadi.Plotting.plot_3d_comp_multinom(model, data, vmin=1, pop_ids =('Indian','EastAsian',"Eurasian"))
dadi.Plotting.plot_3d_comp_multinom(theta*fsms, model, vmin=1, pop_ids =('Indian','EastAsian',"Eurasian"))
pylab.show()
